SystemOrganization addCategory: #'GT-Inspector'!

Object subclass: #GTUnprintableObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector'!

!GTUnprintableObject methodsFor: 'as yet unclassified' stamp: 'JorgeRessia 3/12/2011 13:10'!
printString
	1/0! !

!Object methodsFor: '*gt-inspector' stamp: 'JorgeRessia 3/12/2011 12:08'!
finderVariablesFor: anObject
	^ (OrderedCollection new)
		add: 'self' -> anObject;
		addAll: (anObject class allInstVarNames collect: [ :iv | iv -> (anObject instVarNamed: iv) ]);
		yourself! !

!Object methodsFor: '*gt-inspector' stamp: 'TudorGirba 3/8/2011 19:05'!
objectFinderEvaluatorIn: composite
	<objectFinderPresentationOrder: 100>
	(composite text)
		forSmalltalk;
		display: [ :entity | 'self' ];
		title: 'Evaluator';
		selectionPopulate: #selection
			on: $o
			entitled: 'Open (o)'
			with: [ :text :entity | Compiler evaluate: text selectedText for: entity logged: false ];
		selectionAct: [ :text :entity | (Compiler evaluate: text selectedText for: entity logged: false) inspect ]
			on: $/
			entitled: 'Inspect (/)'! !

!Object methodsFor: '*gt-inspector' stamp: 'TudorGirba 3/9/2011 00:07'!
objectFinderMethodsIn: composite
	<objectFinderPresentationOrder: 50>
	composite custom: (GTSimpleMethodsBrowser new browser startOn: self) ! !

!Object methodsFor: '*gt-inspector' stamp: 'TudorGirba 3/8/2011 19:03'!
objectFinderPresentationsIn: composite
	| pragmas |
	pragmas := Pragma 
				allNamed: #objectFinderPresentationOrder: 
				from: self class 
				to: Object 
				sortedUsing: [: x :y | (x argumentAt: 1) < (y argumentAt: 1)].
	pragmas do: [ :eachPragma | 
		self perform: eachPragma selector with: composite ]
! !

!Object methodsFor: '*gt-inspector' stamp: 'JorgeRessia 3/12/2011 13:48'!
objectFinderVariablesIn: composite
	<objectFinderPresentationOrder: 10>
	(composite list)
		title: 'Variables';
		display: [ :anObject | self finderVariablesFor: anObject ];
		format: [ :assoc |
			| keyString valueString | 
			keyString := [Text fromString: assoc key asString] 
							on: Error 
							do: [Text string: 'error printing' attribute: TextColor red].
			valueString := [Text fromString: (assoc value printString copyFrom: 1 to: ((50 min: assoc value printString size) max: 0))] 
							on: Error 
							do: [Text string: 'error printing' attribute: TextColor red].
			keyString , (Text fromString: ' : ') , valueString ];
		icon: [ :each | OBMorphicIcons iconNamed: each value class theNonMetaClass browserIcon ];
		send: #value! !

!Dictionary methodsFor: '*gt-inspector' stamp: 'JorgeRessia 3/12/2011 12:14'!
finderVariablesFor: anObject  
	^ OrderedCollection new 
		add: ( 'self' -> anObject); 
		add: ( 'tally' -> anObject size );
		add: ( 'array' -> anObject array );
		addAll: ( anObject keysSortedSafely asArray collect: [ :key | key -> (anObject at: key)]);
		yourself
! !

!CompiledMethod methodsFor: '*gt-inspector' stamp: 'JorgeRessia 3/12/2011 12:26'!
finderVariablesFor: anObject
	| literalIndex |
	literalIndex := 0.
	^ OrderedCollection new 
		add: ( 'self' -> anObject); 
		add: ( 'header' -> anObject headerDescription );
		addAll: ( anObject literals collect: [ :aLiteral | 'literal', ( literalIndex := literalIndex + 1 ) asString -> aLiteral ] );
		add: ( 'all bytecodes' -> anObject symbolic );
		yourself
! !

!CompiledMethod methodsFor: '*gt-inspector' stamp: 'JorgeRessia 3/12/2011 10:35'!
objectFinderItemsIn: composite
! !

!Morph methodsFor: '*gt-inspector' stamp: 'TudorGirba 3/9/2011 00:18'!
objectFinderMorphIn: composite
	<objectFinderPresentationOrder: 90>  
	composite morph title: 'Morph'! !

!Form methodsFor: '*gt-inspector' stamp: 'TudorGirba 3/9/2011 00:16'!
objectFinderFormIn: composite
	<objectFinderPresentationOrder: 90>  
	composite morph 
		title: 'Morph';
		display: [:object | object asMorph]! !

!ContextPart methodsFor: '*gt-inspector' stamp: 'JorgeRessia 3/12/2011 12:48'!
finderVariablesFor: anObject
	| tempIndex |
	tempIndex := 0.
	^ ( super finderVariablesFor: anObject )
		addAll: ( anObject tempNames 
					collect: [ :tempName | ( '[', tempName ,']' ) -> (anObject debuggerMap namedTempAt: ( tempIndex := tempIndex + 1 ) in: anObject ) ] );
		yourself! !

GLMBrowserTemplate subclass: #GTInspector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector'!

!GTInspector commentStamp: 'TudorGirba 3/9/2011 00:22' prior: 0!
This is meant to be used for inspecting objects. It offers multiple views and it uses a finder as a navigation. One feature particular feature is that one can use the evaluator tab to enter code, and evaluating it results in opening another pane to the right.

The object finder asks dynamically the object for the actual presentations that are displayed in each pane.

self openOn: Smalltalk.!

!GTInspector methodsFor: 'building' stamp: 'JorgeRessia 3/12/2011 13:09'!
buildBrowser
	browser := GLMFinder new.
	browser title: [:anObject | (self printObjectAsAnItem: anObject), ' - Object Finder'].
	browser show: [ :a | 
		a title: [ :anObject | self printObjectAsAnItem: anObject ].
		a morphicAct: [:composite | composite entity browse] icon: GLMUIThemeExtraIcons glamorousBrowse entitled: 'Browse'.
		a dynamic 
			display: [:each | 
				| dynamic |
				dynamic := GLMCompositePresentation new.
				each objectFinderPresentationsIn: dynamic.
				dynamic ] 		
		"self variablesIn: a.
		self itemsIn: a.
		a custom: self methodsBrowser.
		self evaluatorIn: a "].
	^ browser! !

!GTInspector methodsFor: 'private' stamp: 'tg 12/29/2009 03:43'!
printObjectAsAnItem: anObject 
	| title stream |
	stream := String new writeStream.
	title := anObject class name.
	stream
		nextPutAll: (title first isVowel 
				ifTrue: [ 'an ' ]
				ifFalse: [ 'a ' ]);
		nextPutAll: title.
	^ stream contents! !

!Collection methodsFor: '*gt-inspector' stamp: 'JorgeRessia 3/12/2011 14:31'!
objectFinderItemsIn: composite
	<objectFinderPresentationOrder: 30>  
	 (composite list)
		title: [ :anObject | anObject size asString , ' items' ];
		format: [ :assoc |
			[ Text fromString: assoc asString ] 
							on: Error 
							do: [ Text string: 'error printing' attribute: TextColor red ] ];
		icon: [ :each |  OBMorphicIcons iconNamed: each class theNonMetaClass browserIcon ];
		showOnly: 20 ! !
